package org.purl.jh.esslli.util;

import com.google.common.base.Charsets;
import com.google.common.collect.ImmutableList;
import com.google.common.io.Files;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public final class IO {
    private IO() {}
    
    public static List<List<String>> readSplitStrings(File file, int min) {
        final List<String> lines;
        try {
            lines = Files.readLines(file, Charsets.UTF_8);
        } catch (IOException ex) {
            throw XException.launderThrowable(ex);
        }
        
        final List<List<String>> result = new ArrayList<>();
            
        for (int i = 0; i < lines.size(); i++) {
            String line = lines.get(i);
            int commentIdx = line.indexOf("//");
            if (commentIdx != -1) {
                line = line.substring(0,commentIdx).trim();
            }
            
            if (line.isEmpty()) continue;
            
            // form lemma tag+
            List<String> strs = ImmutableList.copyOf(line.split("\\s+"));
            if (strs.size() < min) {
                System.err.println(line + " " + i);
                throw new FormatException(file, i, 0, "Expecting at least %d items, found only %d", min, strs.size());
            }
            
            result.add(strs);
        }
        
        return result;
    }
}
