package org.purl.jh.esslli.util;

import java.io.IOException;

/**
 *
 * @author Jirka
 */
public class XException extends RuntimeException {

    /** 
     * If the Throwable is an Error, throw it; 
     * if it is a RuntimeException return it, 
     * otherwise throw XException
     * 
     * @param 
     * 
     * Based on Goetz' launderThrowable from Java Concurrency in Practice p.62
     */ 
    public static RuntimeException launderThrowable(Throwable t) { 
        if (t instanceof RuntimeException) 
            return (RuntimeException) t; 
        else if (t instanceof Error) 
            throw (Error) t; 
        else 
            throw new XException(t, "Not unchecked"); 
    } 

    
    public XException() {
    }

    public XException(String aFormat, Object ... aParams) {
        super(String.format(aFormat, aParams));
    }

    public XException(Throwable aCause, String aFormat, Object ... aParams) {
        super(String.format(aFormat, aParams), aCause);
    }
    
    public XException(Throwable aCause) {
        super(aCause);
    }

    public boolean hasIOException() {
        return getCause() instanceof IOException;
    }
    
}
